import '../data/event_option.dart';
import '../data/product.dart';
import '../event/event.dart';

import '../utility/map.dart';
import '../utility/scope.dart';

class AddToCartEvent extends Event {
  static const String CATEGORY = 'airbridge.ecommerce.product.addedToCart';

  String? cartID;
  List<Product>? products;
  String? currency;
  num? totalValue;
  num? totalQuantity;

  AddToCartEvent({
    this.cartID,
    this.products,
    this.currency,
    this.totalValue,
    this.totalQuantity,
    EventOption? option,
  }) : super(CATEGORY, option: option);

  @override
  Map<String, dynamic> toMap() {
    if (option.semantics == null) {
      option.semantics = {};
    }

    option.semantics?.let((semantics) {
      semantics.assignOptional('cartID', cartID);
      semantics.assignOptional('products', products?.toMapList());
      semantics.assignOptional('currency', currency);
      semantics.assignOptional('totalValue', totalValue);
      semantics.assignOptional('totalQuantity', totalQuantity);
    });

    return super.toMap();
  }
}