import '../data/product.dart';
import '../event/event.dart';
import '../data/event_option.dart';

import '../utility/map.dart';
import '../utility/scope.dart';

class PurchaseEvent extends Event {
  static const String CATEGORY = 'airbridge.ecommerce.order.completed';

  String? transactionID;
  List<Product>? products;
  bool? isInAppPurchase;
  String? currency;
  num? totalValue;
  num? totalQuantity;

  PurchaseEvent({
    this.transactionID,
    this.products,
    this.isInAppPurchase,
    this.currency,
    this.totalValue,
    this.totalQuantity,
    EventOption? option,
  }) : super(CATEGORY, option: option);

  @override
  Map<String, dynamic> toMap() {
    if (option.semantics == null) {
      option.semantics = {};
    }

    option.semantics?.let((semantics) {
      semantics.assignOptional('transactionID', transactionID);
      semantics.assignOptional('products', products?.toMapList());
      semantics.assignOptional('inAppPurchased', isInAppPurchase);
      semantics.assignOptional('currency', currency);
      semantics.assignOptional('totalValue', totalValue);
      semantics.assignOptional('totalQuantity', totalQuantity);
    });

    return super.toMap();
  }
}