import '../data/event_option.dart';
import '../data/product.dart';
import '../event/event.dart';

import '../utility/map.dart';
import '../utility/scope.dart';

class ViewProductDetailEvent extends Event {
  static const String CATEGORY = 'airbridge.ecommerce.product.viewed';

  List<Product>? products;

  ViewProductDetailEvent({ this.products, EventOption? option })
      : super(CATEGORY, option: option);

  @override
  Map<String, dynamic> toMap() {
    if (option.semantics == null) {
      option.semantics = {};
    }

    option.semantics?.let((semantics) {
      semantics.assignOptional('products', products?.toMapList());
    });

    return super.toMap();
  }
}