import '../data/user.dart';
import '../utility/log.dart';

import 'package:flutter/services.dart';

class StateAPI {
  final MethodChannel _method;

  StateAPI(this._method);

  void setUser(User user) {
    Log.info('set user');

    _method.invokeMethod('setUser', user.toMap());
  }

  void updateUser(User user) {
    Log.info('update user');

    _method.invokeMethod('updateUser', user.toMap());
  }

  void startTracking() {
    Log.info('start tracking');

    _method.invokeMethod('startTracking');
  }

  Future<String?> get deviceUUID async {
    Log.info('get device uuid');

    return _method.invokeMethod<String?>('getDeviceUUID');
  }
}